SystemOrganization addCategory: #ConfigurationOfSOUL!

Object subclass: #ConfigurationOfSOUL
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfSOUL'!

!ConfigurationOfSOUL class methodsFor: 'development support' stamp: 'AndyKellens 10/28/2011 17:11'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfSOUL class methodsFor: 'private' stamp: 'AndyKellens 10/28/2011 17:11'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfSOUL class methodsFor: 'private' stamp: 'AndyKellens 10/28/2011 17:11'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfSOUL class methodsFor: 'private' stamp: 'AndyKellens 10/28/2011 17:11'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfSOUL class methodsFor: 'metacello tool support' stamp: 'AndyKellens 10/28/2011 17:11'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfSOUL class methodsFor: 'loading' stamp: 'AndyKellens 10/28/2011 17:11'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfSOUL class methodsFor: 'loading' stamp: 'AndyKellens 10/28/2011 17:11'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfSOUL class methodsFor: 'loading' stamp: 'AndyKellens 10/28/2011 17:11'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfSOUL class methodsFor: 'accessing' stamp: 'AndyKellens 10/28/2011 17:11'!
project

	^self new project! !

!ConfigurationOfSOUL class methodsFor: 'development support' stamp: 'AndyKellens 10/28/2011 17:11'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfSOUL methodsFor: 'baselines' stamp: 'AndyKellens 10/28/2011 17:31'!
baseline100: spec
	<version: '1.0-baseline'>
	
	spec for: #common do: [
		
		spec 
			author: 'AndyKellens';
			blessing: #baseline;
			postLoadDoIt:#postLoadSOUL.
			
		spec
			repository: 'http://www.squeaksource.com/SmaccDevelopment/';
			package: 'SmaCC'.	
			
		spec 
			repository: 'http://ss3.gemstone.com/ss/SOUL';
			package: 'SOUL-Kernel' with: [spec requires: {'SmaCC'}];
			package: 'SOUL-GrammarTerms' with: [spec requires: {'SOUL-Kernel'}];
			package: 'SOUL-GrammarClauses' with: [spec requires: {'SOUL-Kernel'}];
			package: 'SOUL-NativeClauses' with: [spec requires: {'SOUL-Kernel'}];
			package: 'SOUL-Repositories' with: [spec requires: {'SOUL-Kernel'}];
			package: 'SOUL-SmalltalkSymbiosis' with: [spec requires: {'SOUL-Kernel' . 'SOUL-EvalPrintLoop'}];
			package: 'SOUL-Parsers' with: [spec requires: {'SmaCC'}];
			package: 'SOUL-LogicPrimitives' with:[spec requires: {'SOUL-Parsers' . 'SOUL-Repositories'}];
			package: 'SOUL-EvalPrintLoop' with: [spec requires: {'SOUL-Kernel'}];
			package: 'SOUL-Tests' with:[spec requires:{'SOUL-Kernel' . 'SOUL-LogicPrimitives'}];
			package: 'LiCoR-Core' with:[spec requires:{'SOUL-Kernel' . 'SOUL-Repositories'}];
			package: 'LiCoR-Predicates' with:[spec requires:{'LiCoR-Core'}];
			package: 'LiCoR-Tests' with:[spec requires:{'LiCoR-Predicates'}].
			
	spec 
		group: 'default' 
		with: #(
			'SOUL-Kernel' 
			'SOUL-GrammarTerms' 
			'SOUL-GrammarClauses' 
			'SOUL-NativeClauses' 
			'SOUL-Repositories' 
			'SOUL-SmalltalkSymbiosis' 
			'SOUL-Parsers' 
			'SOUL-LogicPrimitives' 
			'SOUL-EvalPrintLoop'
			'SOUL-Tests'
			'LiCoR-Core'
			'LiCoR-Predicates'
			'LiCoR-Tests')]! !

!ConfigurationOfSOUL methodsFor: 'post loading' stamp: 'AndyKellens 11/2/2011 09:53'!
postLoadSOUL
	(Smalltalk at: #SoulFactory) initializeRepositories.
	(Smalltalk at: #MLIForPharo) setAsCurrentMLI.
	(Smalltalk at: #SoulFactory) createLiCoRRepositories! !

!ConfigurationOfSOUL methodsFor: 'accessing' stamp: 'AndyKellens 10/28/2011 17:11'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !
